; vector   - triple float dword coordinate
;----------------------in: --------------------------------
;------------------------ esi - pointer to 1st 3d point ---
;------------------------ edi - pointer to 2nd 3d point ---
;------------------------ ebx - pointer to result vector --
;---------------------- out : none ------------------------

make_vector_r:
         movups  xmm0,[esi]
         movups  xmm1,[edi]
         subps   xmm1,xmm0
         movlps  [ebx],xmm1
         movhlps xmm1,xmm1
         movss   [ebx+8],xmm1
ret
;---------------------- in: -------------------------------
;--------------------------- esi - pointer to 1st vector --
;--------------------------- edi - pointer to 2nd vector --
;--------------------------- ebx - pointer to result vector
;---------------------- out : none
cross_product:
      movups  xmm0,[esi]
      movups  xmm1,[esi]
      movups  xmm2,[edi]
      movups  xmm3,[edi]
      shufps  xmm0,xmm0,00001001b
      shufps  xmm1,xmm1,00010010b
      shufps  xmm2,xmm2,00010010b
      shufps  xmm3,xmm3,00001001b
      mulps   xmm0,xmm2
      mulps   xmm1,xmm3
      subps   xmm0,xmm1
      movlps  [ebx],xmm0
      movhlps xmm0,xmm0
      movss   [ebx+8],xmm0

ret

if 0
cross_aligned:
; params as above cross_p
      movaps  xmm0,[esi]
      movaps  xmm1,[esi]
      movaps  xmm2,[edi]
      movaps  xmm3,[edi]
      shufps  xmm0,xmm0,00001001b
      shufps  xmm1,xmm1,00010010b
      shufps  xmm2,xmm2,00010010b
      shufps  xmm3,xmm3,00001001b
      mulps   xmm0,xmm2
      mulps   xmm1,xmm3
      subps   xmm0,xmm1
      movaps  [ebx],xmm0
ret
end if
;----------------------- in: ------------------------------
;---------------------------- edi - pointer to vector -----
;----------------------- out : none
normalize_vector:
        movups   xmm7,[edi]
        movups   xmm0,[edi]
        dpps     xmm7,xmm7,01110111b   ; normalize
        rsqrtps  xmm7,xmm7
        mulps    xmm7,xmm0
        movlps   [edi],xmm7
        movhlps  xmm7,xmm7
        movss    [edi+8],xmm7
ret
