draw_th0:
  xor    eax,eax
  call   draw_thread
  invoke SendMessage,hwnd,WM_FINISH,0,0
  invoke ExitThread,0
ret

draw_th1:
  mov    eax,1
  call   draw_thread
  invoke SendMessage,hwnd,WM_FINISH,0,0
  invoke ExitThread,1
ret
draw_thread:
    push   ebp
    mov    ebp,esp
    sub    esp,70


    .thread_no equ dword[ebp-4]
    .x_min     equ  word[ebp-6]
    .x_max     equ  word[ebp-8]
    .y_min     equ  word[ebp-10]
    .y_max     equ      [ebp-12]
    .third_p_index  equ dword[ebp-16]
    .second_p_index equ dword[ebp-20]
    .first_p_index  equ dword[ebp-24]
    .zz3f           equ dword[ebp-28]
    .zz2f           equ dword[ebp-32]
    .zz1f           equ [ebp-36]
    .1x             equ dword[ebp-40]
    .2x             equ dword[ebp-44]
    .3x             equ dword[ebp-48]
    .bmap           equ [ebp-52]
    .chunk          equ [ebp-56]
;    .bmap           equ [ebp-56]


    mov    .bmap,dword  bump_map
    movzx  ebx,[yres_var]
    shr    ebx,1   ; shr ebx,n ;n=1 - 2 threads, n=2 - 4 threads...
    mov    ecx,ebx
    imul   ebx,eax
    mov    .y_min,bx
    add    ebx,ecx
    mov    .y_max,bx
    mov    .x_min,0
    push   word[xres_var]
    pop    .x_max

    mov    eax,1
    .2cond:

    mov    esi,triangles            ; draw triangles
    xor    ecx,ecx
.draw_triangle:
    push   eax
    push   ecx
    push   esi
    emms

        mov      ebx,ecx
        add      ebx,ebx
        add      ebx,chunks  ; adress
        movzx    ebx,word[ebx]
        dec      ebx


        mov      .chunk,ebx

        cmp      ebx,0
        cmovne   ebx,[i1]
        cmp      ebx,eax
        jne      .end_draw



    movzx       edx,word[esi]
    shl         edx,2
    mov         .1x,edx
    lea         edx,[edx*3]
    mov         .first_p_index,edx
    add         edx,points_rotated
    movlps      xmm0,[edx]
    cvtps2dq    xmm0,xmm0
    packssdw    xmm0,xmm0
    movd        eax,xmm0
    ror         eax,16  ;proteza
    push        dword[edx+8]
    pop         dword .zz1f

    movzx       edx,word[esi+2]
    shl         edx,2
    mov         .2x,edx
    lea         edx,[edx*3]
    mov         .second_p_index,edx
    add         edx,points_rotated
    movlps      xmm0,[edx]
    cvtps2dq    xmm0,xmm0
    packssdw    xmm0,xmm0
    movd        ebx,xmm0
    ror         ebx,16
    push        dword[edx+8]
    pop         .zz2f

    movzx       edx,word[esi+4]
    shl         edx,2
    mov         .3x,edx
    lea         edx,[edx*3]
    mov         .third_p_index,edx
    add         edx,points_rotated
    movlps      xmm0,[edx]
    cvtps2dq    xmm0,xmm0
    packssdw    xmm0,xmm0
    movd        ecx,xmm0
    ror         ecx,16
    push        dword[edx+8]
    pop         .zz3f


     mov     edx,.first_p_index
     mov     esi,.second_p_index
     mov     edi,.third_p_index
     movups  xmm0,[edx+points_normals_rotated]
     movups  xmm1,[esi+points_normals_rotated]
     movups  xmm2,[edi+points_normals_rotated]
     andps   xmm0,[mask_h_zero]
     andps   xmm1,[mask_h_zero]
     andps   xmm2,[mask_h_zero]
     mov     edx,1.0
     movd    xmm3,edx
     pshufd  xmm3,xmm3,11001111b
     movups  xmm4,.zz1f
     andps   xmm4,[mask_h_zero]
     xorps   xmm6,xmm6
     movq    xmm5,.y_max
     punpcklwd xmm5,xmm6
; is      lo -> hi     ymax, ymin, xmax, xmin
; will be lo -> hi     ymin, ymax, xmin, xmax
     pshufd  xmm5,xmm5,10110001b

     mov     edx,.1x
     mov     esi,.3x
     mov     edi,.2x
     mov     edx,[edx+tex_coords]
     mov     esi,[esi+tex_coords]
     mov     edi,[edi+tex_coords]

     movd    xmm6,edx
     movd    xmm7,esi
     movlhps xmm6,xmm7
     movd    xmm7,edi
     pslldq  xmm7,4
     por     xmm6,xmm7
     movzx   edx,word[xres_var]
     movd    xmm7,edx
     pslldq  xmm7,12
     por     xmm6,xmm7
     movd    xmm7,[Sbuffer_ptr]
     movhps  xmm7,.chunk
     shufps  xmm7,xmm7,01111000b
     mov     edi,[screen_ptr]   ; screen buffer
     mov     esi,[Zbuffer_ptr]
     mov     edx,texmap

     call  glass_tex_tri

 .end_draw:

    pop    esi
    pop    ecx
    pop    eax
    add    esi,6
    inc    ecx
    cmp    cx,[triangles_count_var]
    jnz    .draw_triangle


    dec    eax
    cmp    eax,-1
    jne    .2cond      ; next pass


    add esp,70
    pop ebp
ret
