;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Stabat Mater Dolorosa
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; program : Mater Dolorosa  -> 3d rotozoomer. Textured
;;           with bilinear filtering, 3d object
;;           illuminated by three unlinear lights, also
;;           I implemented transparency and bump effect.
;; author  : Maciej Guba aka macgub
;; web     : www.macgub.co.pl
;; email   : macgub3@wp.pl
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Credits:
;;   Big thanks to Jan Pawel II, Tomasz Grysztar, Madis
;;   Kalme, Mikolaj Feliks, James Foley, Ica, Chem, 
;;   lostcauz, tthsqe, and  all from 
;;   http://board.flatassembler.net.
;;   It's 32 bit sse4 app.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

format PE GUI 4.0
entry start

include '/include/win32a.inc'

TEX_X = 128    ; texture size
TEX_Y = 128
TEX_SIZE EQU (TEX_X * TEX_Y)-1
TEX_SHIFT = 7
ROUND equ 8
WM_FINISH equ WM_USER+100h

section '.text' code readable executable
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; start and message loop
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
start:

    invoke GetModuleHandle,0
    mov [wc.hInstance],eax
    invoke LoadIcon,0,IDI_APPLICATION
    mov [wc.hIcon],eax
    invoke LoadCursor,0,IDC_ARROW
    mov [wc.hCursor],eax

    invoke  GetSystemMetrics,SM_CXSCREEN
    sub     eax,10
    and     eax,0xfffffffe
    push    eax
    mov     [xres_var],ax
    shr     eax,1
    mov     [xxadd],ax
    invoke  GetSystemMetrics,SM_CYSCREEN
    sub     eax,10
    and     eax,0xfffffffe
    push    eax
    mov     [yres_var],ax
    mov     ecx,eax
    shr     ecx,1
    mov     [yyadd],cx

    pop eax
    pop ebx

    mov [bmi.biSize],sizeof.BITMAPINFOHEADER
    mov [bmi.biWidth],ebx
    neg eax
    mov [bmi.biHeight],eax
    mov [bmi.biPlanes],1
    mov [bmi.biBitCount],32
    mov [bmi.biCompression],BI_RGB

    mov [bmi.biSizeImage],0
    mov [bmi.biXPelsPerMeter],0
    mov [bmi.biYPelsPerMeter],0
    mov [bmi.biClrUsed],0
    mov [bmi.biClrImportant],0

    mov [rect.left],0
    mov [rect.top],0
    mov [rect.right],ebx
    neg eax
    mov [rect.bottom],eax
    invoke AdjustWindowRect,rect,WS_POPUP or WS_SYSMENU or WS_CAPTION,0 

    invoke RegisterClass,wc

    mov ecx,[rect.bottom]
    mov eax,[rect.right]
    sub ecx,[rect.top]
    sub eax,[rect.left] 

    invoke CreateWindowEx,0,_class,_title,WS_OVERLAPPEDWINDOW\
           xor WS_THICKFRAME xor WS_MAXIMIZEBOX,0,0,eax,ecx,NULL,NULL,0,0
    mov [hwnd],eax
    invoke GetDC,[hwnd]
    mov [hdc],eax
    invoke ShowWindow,[hwnd],SW_SHOW


     movzx   eax,word[xres_var]
     movzx   ebx,[yres_var]
     mul     ebx
     shl     eax,2
     mov     ebx,eax
     invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
     or  eax,eax
     jnz @f
     int3
   @@:
     mov     [screen_ptr],eax

     invoke  VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
     or  eax,eax
     jnz @f
     int3
   @@:
     mov     [Zbuffer_ptr],eax

     invoke  VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
     or  eax,eax
     jnz @f
     int3
   @@:
     mov     [Sbuffer_ptr],eax





   mov  eax,triangles
   mov  ebx,points
   mov  ecx,file3ds
   call read_from_file
   mov  [points_count_var],cx
   mov  [triangles_count_var],dx




     movzx    eax,[yres_var]
     shr      eax,2
     cvtsi2ss xmm0,eax
     movss  [scale],xmm0

   mov   edi,texmap
   mov   ecx,TEX_X*TEX_Y
   or    eax,-1
   cld
   rep   stosd




   mov    esi,chunks  ;roses+1078   ; 118   - 4 bit
   mov    edi,texmap
   add    edi,128*50*4
   mov    ecx,34*TEX_Y  ;/2
  @@:
   std
   lodsb
   movzx  eax,al
   shl    eax,2
   add    eax,[palette]
   mov    eax,[eax]
   cld
   and    eax,0x00ffffff
   stosd
   loop  @b

   mov  esi,texmap
   mov  edi,bump_map
   call calc_bumpmap




   mov  edi,lights_aligned
   mov  ecx,3
   call norm_aligned_lv


    pushad
    push   dword points_r
    movzx  ecx,[points_count_var]
    push   ecx
    call   normalize_object1
    popad

    mov      esi,points_r
    mov      edi,tex_coords
    movzx    ecx,[points_count_var]
    mov      eax,TEX_X/2
;    mov      ebx,3
;    cvtsi2ss xmm3,ebx
;    pslldq   xmm3,4
    cvtsi2ss xmm1,eax
    shufps   xmm1,xmm1,11110000b
  @@:
    movups  xmm0,[esi]
;    shufps  xmm0,xmm0,11110001b
    mulps   xmm0,xmm1
    addps   xmm0,xmm1
;    subps   xmm0,xmm3
    cvtps2dq xmm0,xmm0
    packssdw xmm0,xmm0
    movd    [edi],xmm0
    add     edi,4
    add     esi,12
    loop    @b


    call   init_triangles_normals2
    call   init_point_normals

msg_loop:

    stdcall g_draw
    inc    [ccounter]
    and    [ccounter],0x000001ff
    movzx  eax,word[xres_var]
    movzx  ebx,[yres_var]
    invoke StretchDIBits,[hdc],0,0,eax,ebx,0,0,eax,ebx,[screen_ptr],bmi,0,SRCCOPY
                                           ; debug -   [screen_ptr]
    cmp    [speed_flag],1
    je     @f
    invoke Sleep,3
  @@:

    invoke PeekMessage,msg,0,0,0,PM_NOREMOVE
    or eax,eax
    je msg_loop

    invoke GetMessage,msg,NULL,0,0
    or     eax,eax
    je     end_loop

    invoke TranslateMessage,msg
    invoke DispatchMessage,msg
    jmp    msg_loop

error:
    invoke MessageBox,NULL,_error,NULL,MB_ICONERROR+MB_OK

end_loop:
    invoke ReleaseDC,[hwnd],[hdc]
    invoke DestroyWindow,[hwnd]
    invoke ExitProcess,[msg.wParam]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; WindowProc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc WindowProc uses ebx esi edi, hwnd,wmsg,wparam,lparam
    cmp [wmsg],WM_KEYDOWN
    je  .wmkeydown
    cmp [wmsg],WM_DESTROY
    je  .wmdestroy
  .defwndproc:
    invoke DefWindowProc,[hwnd],[wmsg],[wparam],[lparam]
    jmp    .finish
  .wmkeydown:
    cmp     [wparam],VK_UP
    jne     .vescape

    xor eax,eax
    jmp .finish
  .vescape:

    cmp [wparam],VK_SPACE
    jne @f
    not [speed_flag]
    and [speed_flag],1
   @@:


    cmp [wparam],VK_ESCAPE
    jne .finish
  .wmdestroy:
    invoke PostQuitMessage,0
    xor eax,eax
  .finish:
    ret
endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; g_draw - draw to screen buffer; main program proc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc g_draw

    push ebp
    mov  ebp,esp


    pushad

    xor   eax,eax          ; clear draw buffer
    mov   edi,[screen_ptr]
    movzx ebx,[yres_var]
    movzx ecx,word[xres_var]
    imul  ecx,ebx
    call  fill_aligned

    mov   eax,60000.1
    mov   edi,[Sbuffer_ptr]   ; stencil buffer
    movzx ebx,[yres_var]
    movzx ecx,word[xres_var]
    imul  ecx,ebx
    call  fill_aligned

    mov   eax,60000.1
    mov   edi,[Zbuffer_ptr]
    movzx ebx,[yres_var]
    movzx ecx,word[xres_var]
    imul  ecx,ebx
    call  fill_aligned





    fninit
    fild   [ccounter]
    fmul   [one_deg]

    fld    st
    fsincos
    fst   dword[cos_beta]
    fchs
    fstp  [neg_cos_beta]
    fst   [sin_beta]
    fchs
    fstp  [neg_sin_beta]

  @@:
    fld1
    fld1
    faddp
    fmulp

    fsincos
    fst   dword[cos_gamma]
    fchs
    fstp  [neg_cos_gamma]
    fst   [sin_gamma]
    fchs
    fstp  [neg_sin_gamma]

 ; .rot_points
    mov    esi,points_r         ; rotate points
    mov    edi,points_rotated
    movzx  ecx,[points_count_var]
    call   rotor
 ;.rot_normals:
    mov    esi,points_normals
    mov    edi,points_normals_rotated
    movzx  ecx,[points_count_var]
    call   rotor


    cmp   [scale_cnt],912       ; scale counter
    jne   @f
    mov   [scale_dir],1         ; scale direction
  @@:
    cmp   [scale_cnt],0
    jne   @f
    mov   [scale_dir],0
  @@:
    movss xmm0,[scale]
    cmp   [scale_dir],0
    jne   @f
    mulss xmm0,[scale_inc]
    add   [scale_cnt],1
    jmp   .finish_scale
  @@:
    mulss xmm0,[scale_dec]
    sub   [scale_cnt],1
  .finish_scale:
    movss  [scale],xmm0
   ;translate

    mov          esi,points_rotated
    movq         xmm0,[xxadd]
    punpcklwd    xmm0,[the_zero]
    cvtdq2ps     xmm0,xmm0
    movzx        ecx,[points_count_var]
    movss        xmm3,[scale]
    shufps       xmm3,xmm3,0
  @@:
    movups   xmm1,[esi]
    mulps    xmm1,xmm3
    addps    xmm1,xmm0
    movlps   [esi],xmm1
    movhlps  xmm1,xmm1
    movss    [esi+8],xmm1
    add      esi,12
    loop      @b


 ; stencil buffer -> determines front of object

    mov    esi,triangles
    movzx  ecx,[triangles_count_var]
 .again_stencil_tri:
    push   esi
    push   ecx
    movzx  edx,word[esi]
    movzx  eax,word[esi+2]
    movzx  ebx,word[esi+4]
    shl    edx,2
    shl    eax,2
    shl    ebx,2
    lea    edx,[edx*3]
    lea    eax,[eax*3]
    lea    ebx,[ebx*3]
    add    edx,points_rotated
    add    eax,points_rotated
    add    ebx,points_rotated
    movss  xmm3,[edx+8]
    movss  xmm4,[eax+8]
    movss  xmm5,[ebx+8]
    movlps xmm0,[edx]
    movlps xmm1,[eax]
    movlps xmm2,[ebx]

    shufps  xmm4,xmm4,11110011b
    orps    xmm3,xmm4
;    shufps  xmm3,xmm3,11111000b
    movlhps xmm3,xmm5  ; xmm3 - z float pack
  ;  orps     xmm3,[zero_hgst_dd]
  ;  shufps  xmm3,xmm3,11000110b

    shufps   xmm0,xmm0,11100001b
    shufps   xmm1,xmm1,11100001b
    shufps   xmm2,xmm2,11100001b

    cvtps2dq xmm0,xmm0
    cvtps2dq xmm1,xmm1
    cvtps2dq xmm2,xmm2
    packssdw xmm0,xmm0
    packssdw xmm1,xmm1
    packssdw xmm2,xmm2
    movd     eax,xmm0
    movd     ebx,xmm1
    movd     ecx,xmm2
    movaps   xmm0,xmm3
    mov      esi,[Sbuffer_ptr]

    call     stencil_tri

    pop      ecx
    pop      esi
    add      esi,6
    dec      ecx
    jnz      .again_stencil_tri


    invoke  CreateThread,NULL,NULL,draw_th0,\
            NULL,NORMAL_PRIORITY_CLASS,\
            [ThreadID0]
    mov     [hthread0],eax
    invoke  SetThreadPriority,hthread0,THREAD_PRIORITY_TIME_CRITICAL

    invoke  CreateThread,NULL,NULL,draw_th1,\
            NULL,NORMAL_PRIORITY_CLASS,\
            [ThreadID1]
    mov     [hthread1],eax
    invoke  SetThreadPriority,hthread1,THREAD_PRIORITY_TIME_CRITICAL

    invoke  SetThreadAffinityMask,[hthread0],1
    invoke  SetThreadAffinityMask,[hthread1],2
    invoke  ResumeThread,[hthread0]
    invoke  ResumeThread,[hthread1]
    invoke  WaitForMultipleObjectsEx,2,hthread0,1,-1,0
    invoke  CloseHandle,hthread0   ;2
    invoke  CloseHandle,hthread1


    popad

    pop ebp
ret

endp

fill_aligned:
;in  eax - dword value to fill,
;    ecx - area size in dwords
;    edi - mem adress
;    addres must be aligned

  .fill_sse:
    shr     ecx,2
    or      ecx,ecx
    jz      .end
    movd    xmm0,eax
    shufps  xmm0,xmm0,0
  @@:
    movaps  [edi],xmm0
    add     edi,16
    loop    @b
  .end:
ret

rotor:
 ;  esi -  points/normals to rotate
 ;  edi -  rotated points/normals
 ;  ecx -  points(vertices)/normal vectors count
 .again_rot:
  ;  movlps xmm0,[esi+4]
  ;  shufps xmm0,xmm0,01000100b
  ;  movaps xmm1,[cos_gamma]
  ;  shufps xmm1,xmm1,00110100b
  ;  mulps  xmm0,xmm1
  ;  haddps xmm0,xmm0
  ;  movlps [edi+4],xmm0

;    push   dword[esi]
;    pop    dword[edi]
    movups  xmm0,[esi]
    movups  [edi],xmm0



    movups xmm2,[edi]
    shufps xmm2,xmm2,10001000b
    movaps xmm3,[cos_beta]
    shufps xmm3,xmm3,00011100b
    mulps  xmm3,xmm2
    haddps xmm3,xmm3

    movss  [edi+8],xmm3
    psrldq xmm3,4
    movss  [edi],xmm3
    add    esi,12
    add    edi,12
    loop   .again_rot
ret



init_triangles_normals2:
        mov     ebx,triangles_normals
        mov     ebp,triangles
        movzx   ecx,[triangles_count_var]
     @@:
        push    ecx
        push    ebx
        mov     ebx,vectors
        movzx   esi,word[ebp]          ; first point index
        lea     esi,[esi*3]
     ; esi - pointer to 1st 3d point
        shl     esi,2
        add     esi,points_r
        movzx   edi,word[ebp+2]          ; first point index
        lea     edi,[edi*3]
        shl     edi,2
        add     edi,points_r
     ; second point index
     ; edi - pointer to 2nd 3d point

        call    make_vector_r
        add     ebx,12
        mov     esi,edi
        movzx   edi,word[ebp+4]        ; third point index
        lea     edi,[edi*3]
        shl     edi,2
        add     edi,points_r
        call    make_vector_r
        mov     edi,ebx                 ; edi - pointer to 2nd vector
        mov     esi,ebx
        sub     esi,12                  ; esi - pointer to 1st vector
        pop     ebx
        call    cross_product
        mov     edi,ebx
        call    normalize_vector
        add     ebp,6
        add     ebx,12
        pop     ecx
        loop    @b
ret

init_point_normals:

        mov       edi,points_normals ;[points_normals_ptr]
        xor       edx,edx
    .ipn_loop:
        xorps     xmm0,xmm0
        mov       esi,triangles;[triangles_ptr]
        xor       ecx,ecx              ; ecx - triangle number
    .ipn_check_face:
        xor       ebx,ebx              ; ebx - 'position' in one triangle
    .ipn_check_vertex:
        movzx     eax,word[esi+ebx]    ;  eax - point_number
        cmp       eax,edx
        jne       .ipn_next_vertex
        push      esi
        mov       esi,ecx
        lea       esi,[esi*3]
        shl       esi,2
        add       esi,triangles_normals
        movups    xmm1,[esi]
        addps     xmm0,xmm1
        pop       esi
        jmp       .ipn_next_face
    .ipn_next_vertex:
        add       ebx,2
        cmp       ebx,6
        jne       .ipn_check_vertex
    .ipn_next_face:
        add       esi,6
        inc       ecx
        cmp       cx,[triangles_count_var]
        jne       .ipn_check_face
        movlps    [edi],xmm0
        movhlps   xmm0,xmm0
        movss     [edi+8],xmm0
        call      normalize_vector
        add       edi,12  ;type vector 3d
        inc       edx
        cmp       dx,[points_count_var]
        jne       .ipn_loop

ret


norm_aligned_lv:     ; normalise aligned light vectors
;  in edi -> lights_ptr
;     ecx -> lights count
    @@:
     movaps  xmm0,[edi]
     movaps  xmm1,[edi]
     mulps   xmm1,xmm1
     haddps  xmm1,xmm1
     haddps  xmm1,xmm1
     rsqrtps xmm1,xmm1
     mulps   xmm0,xmm1
     movaps  [edi],xmm0
     add     edi,64
     loop    @b
ret

read_from_file:
;; this procedure coded orginally by Madis Kalme
;; some changes by me
;; Thanks a lot Madis!!!
;in:
;     eax - triangles ptr
;     ebx - vertices ptr
;     ecx - file ptr
;out:
;     ecx - vertices count
;     edx - triangles count
        push    ebp
        mov     ebp,esp
        sub     esp,40

        .triangles_p equ [ebp-4]
        .vert_p      equ [ebp-8]
        .file        equ [ebp-12]
        .file_end    equ [ebp-16]
        .vert_cnt    equ [ebp-20]
        .tri_cnt     equ [ebp-24]

        mov     .triangles_p,eax
        mov     .vert_p,ebx
        mov     .file,ecx
        mov     edi,eax  ;[triangles_ptr]
        xor     ebx,ebx
        mov     dword .vert_cnt,0
        mov     dword .tri_cnt,0
        cld

        mov     esi,ecx

        cmp     [esi],word 4D4Dh
        jne     .exit ;Must be legal .3DS file
;        cmp     dword[esi+2],EndFile-SourceFile
;        jne     .exit ;This must tell the length
        mov     eax,dword[esi+2]
  ;      cmp     eax,[fsize]
  ;      jne     .exit

        add     eax,esi
        mov     .file_end,eax    ;
        xor     eax,eax
        add     esi,6
      @@:
        cmp     [esi],word 3D3Dh
        je      @f
        add     esi,[esi+2]
        jmp     @b
      @@:
        add     esi,6
      .find4k:
        cmp     [esi],word 4000h
        je      @f
        add     esi,[esi+2]
        cmp     esi,.file_end
        jc      .find4k
        jmp     .exit
      @@:
        add     esi,6
      @@:
        cmp     [esi],byte 0
        je      @f
        inc     esi
        jmp     @b
      @@:
        inc     esi
      @@:
        cmp     [esi],word 4100h
        je      @f
        add     esi,[esi+2]
        jmp     @b
      @@:
        add     esi,6
      @@:
        cmp     [esi],word 4110h
        je      @f
        add     esi,[esi+2]
        jmp     @b
      @@:
        movzx   ecx,word[esi+6]
        add     .vert_cnt,cx

        mov     edx,ecx
        add     esi,8
     @@:
        push    edi
        mov     edi,.vert_p
        lea     edi,[edi+ebx*2]
        movsd
        movsd
        movsd
        pop     edi
        add     ebx,6
        loop    @b
      @@:
        push    edi
        mov     edi,.vert_p
        mov     dword[edi+ebx*2],-1    ; end mark (not always in use)
        pop     edi
      @@:
        cmp     [esi],word 4120h
        je      @f
        add     esi,[esi+2]
        jmp     @b
      @@:
        movzx   ecx,word[esi+6]
        add     .tri_cnt,cx
        add     esi,8
       @@:
        movsd
        movsw
        add     word[edi-6],ax ;bp
        add     word[edi-4],ax ;bp
        add     word[edi-2],ax ;bp
        add     esi,2
        loop    @b

        add     eax,edx
        jmp     .find4k
        mov     eax,-1 ;<---mark if OK
      .exit:
        movzx ecx,word .vert_cnt
        movzx edx,word .tri_cnt
        mov   ebx,.file_end
        mov   esp,ebp
        pop   ebp
ret

include '3dmath.inc'
include 'procs_a.inc'
include '3glass_tex.inc'
include 'stencil3.inc'
include 'draw.inc'

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
section '.data' data readable writeable
    _class    TCHAR 'grtest',0
    _title    TCHAR 'Mater Dolorosa, press space -> speed - full/idle ',0
    _error    TCHAR 'Startup failed.',0
    ccounter    dd  0
    i1          dd  1
    i3          dd  3
    i12         dd  12
    i256        dw  256
    i255d       dd  255
    speed_flag  db  1
    scale_dir   db  0
    scale_cnt   dw  350
    scale_inc   dd  1.0017      ; scale increment
    scale_dec   dd  0.998302885  ; scale decrement

    scale       dd 200.0
    xxadd:      dw ?
    yyadd       dw ?
    zzadd       dw 0
                dw 0
;  piD256:
    one_deg     dd  0.01227
    aprox       dd  1.1

align 16                                               ;      a1
                                                       ;     b2c3
 tex_m2:         dd 124.0, 124.0, 124.0, 124.0         ;     4d56
 tex_2:          times 4 dd 2.0                        ;      78
 bump_consts:    dd -1 , 1, -TEX_Y, TEX_Y              ;
 bump_consts2:   dd -TEX_Y,-1,TEX_Y-1,TEX_Y*2
 bump_trunc:     times 4 dd TEX_SIZE
 norm_dev:       times 2 dd 0.023
                 dd 0, 0 ; normal vec deviation
 mask_255f:      dd 255.0, 255.0, 255.0, 255.0
 the_zero:       dd 0, 0, 0, 0
 the_one:        dd 1.0, 1.0, 1.0, 1.0
 mask_h_zero:    dd -1, -1, -1, 0
 abs_val:        dd 0x7fffffff, 0x7fffffff, 0x7fffffff, 0x7fffffff
 b_shf1:         db 4, 5, 8, 9, 0, 1, 5, 6
 b_shf2:         db 6, 7, 10, 11, 9, 10, 2, 3



align 16

  lights_aligned:
    .light_vect    dd   0.0, 0.0, -1.0, 0.0
    .light_c_o:    dd   115.0, 81.0, 114.0, 0.0
    .light_c_min:  dd   30.0, 20.0, 13.0, 0.0
    .light_c_max:  dd   255.0, 205.0, 255.0, 0.0

       dd   -0.5,-0.5,-1.0, 0.0
       dd   2.0, 27.0, 170.0, 0.0
       dd   1.0,1.0,1.0,0.0
       dd   5.0,255.0,255.0,0.0


       dd   0.5,0.5,-1.0,0.0
       dd   3.0,1.0,8.0,0.0
       dd   7.0,3.0,17.0,0.0
       dd   5.0, 255.0,150.0, 0.0

 lights_aligned_end:


align  16

color:
   dd 1.0 , 1.0, 1.0 , 0
   dd 25.0 , 111.0 ,2.0 , 0
   dd 2.0 , 255.0, 0 , 0
   dd 1.0 , 2.0,255.0 , 0
   dd 111.0 , 111.0, 1.0 , 0
   dd 255.0 , 0 ,2.0 , 0
   dd 111.0 , 111.0, 0 , 0
   dd 111.0 , 111.0,111.0 , 0
   dd 111.0 , 111.0, 1.0 , 0

abs_z_coof:
              dd -1,-1,0x7fffffff,0




;eps_d:
;epsilon_d:    times 4 dq 0.000001
;facT:  times 3  dd  0.133
;                dd 0
;facR:  times 3  dd  0.933
;                dd 0
zero_hgst_dd:
       dd 0xffffffff, 0xffffffff, 0xffffffff, 0x00000000

           point_light_coords:
              dd 50.0
              dd 50.0
              dd -215.0
              dd 0.0


              dd 815.0
              dd 815.0
              dd -215.0
              dd 0.0

              dd 1500.0
              dd 1500.0
              dd -215.0
              dd 0.0
;eps:
;epsilon:    times 4 dd 0.0000001
;rcp3:       times 3 dd 0.33333
;                    dd 0
;epsminus    dd -0.0000001
;epsone      dd 1.0000001


palette:
    dd   roses + 54
roses:
   file 'roses8_34.bmp'
chunks:
   file 'chunks.bin'
file3ds:
   file 'md.3ds'

    msg  MSG
    rect RECT
    wc WNDCLASS 0,WindowProc,0,0,NULL,NULL,NULL,1,NULL,_class

    screen_ptr  dd ?
    Zbuffer_ptr dd ?
    Sbuffer_ptr dd ?
    xres_var:   dw ?
    yres_var    dw ?

align 16

    cos_beta:
                  rd 1
    sin_beta      dd ?
    neg_cos_beta  dd ?
    neg_sin_beta  dd ?

    cos_gamma:
                  rd 1
    sin_gamma     dd ?
    neg_cos_gamma dd ?
    neg_sin_gamma dd ?


    points_count_var    dw ?
    triangles_count_var dw ?


    hwnd      dd ?
    hdc       dd ?
    bmi       BITMAPINFOHEADER

   points:
   points_r:   rd 12 * 1100
   triangles   rd 12 * 2000



    texmap    rd TEX_X * TEX_Y
    bump_map  rb TEX_X * TEX_Y * 16


    points_rotated:
       rd  1100 *12
    triangles_normals:
       rd  2000 *12
    points_normals:
       rd  1100 *12
    points_normals_rotated:
       rd  1100 *12
    tex_coords:
       rd  2000
    vectors     rb 24
    ThreadID0   dd ?
    ThreadID1   dd ?
    ThreadID2   dd ?
    hthread0    rd 1
    hthread1    rd 1

section '.idata' import data readable writeable
    library kernel32,'KERNEL32',\user32,'USER32',\gdi32,'GDI32',\winmm,'WINMM'
    include '\include\api\kernel32.inc'
    include '\include\api\user32.inc'
    include '\include\api\gdi32.inc'




